## ?zip=Linux%2Fhandhelds%2Fpackages%2Fifupdown

=== Makefile ===
CFLAGS := -Wall -W -g -O2 -D'IFUPDOWN_VERSION="0.6.4"'
CC := $(CROSS_COMPILE)gcc

CFILES := addrfam.c execute.c config.c main.c archlinux.c
HFILES := header.h archlinux.h
PERL := defn2c.pl defn2man.pl
DEFNFILES := inet.defn ipx.defn inet6.defn

OBJ := main.o addrfam.o execute.o config.o \
	$(patsubst %.defn,%.o,$(DEFNFILES)) archlinux.o

MAN := $(patsubst %.defn,%.man,$(DEFNFILES))

default : executables
all : executables docs

executables : ifup ifdown ifup.8 ifdown.8 interfaces.5
docs : ifupdown.ps.gz ifup.8.ps.gz interfaces.5.ps.gz ifupdown.pdf

.PHONY : executables 
.PHONY : clean clobber

install :
	install -m 0755 -d     ${BASEDIR}/sbin
	install -m 0755 ifup   ${BASEDIR}/sbin
	ln ${BASEDIR}/sbin/ifup ${BASEDIR}/sbin/ifdown	

ipkg:
	rm -fr root
	make BASEDIR=$$PWD/root install
	mkdir -p root/CONTROL root/etc/network root/etc/init.d
	for d in if-down.d if-post-down.d if-pre-up.d if-up.d; do mkdir -p root/network/$d; done
	ln -s /mnt/ramfs/etc/network/ifstate root/etc/network/ifstate
	cp debian/ifupdown.init root/etc/init.d/ifupdown
	cp familiar/control familiar/conffiles  root/CONTROL
	cp familiar/interfaces root/etc/network
	$(CROSS_COMPILE)strip root/sbin/*
	ipkg-build -g root -o root root

clean :
	rm -f *.aux *.toc *.log *.bbl *.blg *.ps *.eps
	rm -f *.o *.d $(patsubst %.defn,%.c,$(DEFNFILES)) *~
	rm -f $(patsubst %.defn,%.man,$(DEFNFILES))
	rm -f ifup ifdown interfaces.5 ifdown.8
	rm -f ifupdown.dvi *.ps{,.gz} ifupdown.pdf

clobber : clean
	rm -f ifupdown.tex $(PERL) $(CFILES) $(HFILES) $(DEFNFILES)

distclean : clobber
	rm -f makecdep.sh makenwdep.sh Makefile
ifup: $(OBJ)
	$(CC) $(CFLAGS) -o ifup $^

ifdown: ifup
	ln -sf ifup ifdown
interfaces.5: interfaces.5.pre $(MAN)
	LINE=$$(grep -n '^##ADDRESSFAM##$$' $< | sed 's/:.*//g'); \
	WC=`wc -l < $<`;                                          \
	(                                                         \
	  head -$$(($$LINE - 1)) $<;                              \
	  cat $(MAN);                                             \
	  tail -$$(($$WC - $$LINE)) $<;                           \
	) > $@

ifdown.8: ifup.8
	ln -sf $< $@

%.5.ps: %.5
	groff -mandoc -Tps $< > $@
%.8.ps: %.8
	groff -mandoc -Tps $< > $@
ifupdown.ps: modules.eps execution.eps
ifupdown.pdf: modules.pdf execution.pdf
%.tex : %.nw
	noweave -delay -index -latex $< >$@

%.bbl : %.tex biblio.bib
	latex $<
	bibtex $(basename $<)

%.dvi : %.tex %.bbl
	latex $<
	latex $<

%.pdf : %.tex %.bbl
	pdflatex $<
	pdflatex $<

%.ps : %.dvi
	dvips -o $@ $<

%.gz : %
	gzip --best --stdout $< >$@
%.eps : %.dia
	dia -e $@ $<

%.pdf : %.eps
	gs -q -sDEVICE=pdfwrite -dNOPAUSE -sOutputFile=$@ - < $<
%.d: %.nw makenwdep.sh
	./makenwdep.sh $< > $@
%.d: %.c makecdep.sh
	./makecdep.sh $< > $@
%.c : %.defn defn2c.pl
	./defn2c.pl $< > $@
%.man: %.defn defn2man.pl
	./defn2man.pl $< > $@

include ifupdown.d

=== debian/control ===
Source: ifupdown
Section: net
Priority: extra
Maintainer: Anthony Towns <ajt@debian.org>
Standards-Version: 3.1.1
Build-Depends: debhelper

Package: ifupdown
Architecture: any
Depends: net-tools, ${shlibs:Depends}
Suggests: iproute
Replaces: netbase (<< 4.00)
Description: High level tools to configure network interfaces
 This package provides the tools ifup and ifdown which may be used to
 configure (or, respectively, deconfigure) network interfaces, based on
 the file /etc/network/interfaces.

=== debian/rules ===
#!/usr/bin/make -f

######################################################################
# BUILD NOTES
#
# ifupdown's written in litprog using noweb. noweb is written in icon.
# icon isn't as portable as one might hope (it needs to have bits recoded
# for each arch and OS it's ported to. ugh).
#
# So. The "upstream" source is made to not include any of the generated
# files. That's neat and tidy. If you want to modify anything, you edit
# the .nw file.
#
# Once you've done all the Debian changes, you run debian/rules binary,
# and get all the .c files and such updated. Once you're done, you
# run debian/rules clean, which leaves the generated .c files around
# for porters. You then generate a .diff.gz, and all should be well.
######################################################################

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=1

configure:
	dh_testdir
	# Add here commands to configure the package.

build: configure
	dh_testdir

	# Add here commands to compile the package.
	if [ -x /usr/bin/noweb ]; then \
	  $(MAKE) clobber; \
	else \
	  chmod a+rx defn2c.pl defn2man.pl makecdep.sh makenwdep.sh; \
	fi
	$(MAKE)

test: build
	dh_testdir

	# Add here commands to test the package works.
	chmod a+rx debian/testbuild
	@echo running debian/testbuild
	@if ! debian/testbuild; then \
	     echo '=================================================='; \
	     echo 'AUTOMATIC TESTS FAILED -- Something built wrong or'; \
	     echo 'there is a bug in the code!!! Either way something'; \
	     echo 'is completely screwed up!!! File a bug!'; \
	     echo ''; \
	     echo 'Aborting build.'; \
	     echo '=================================================='; \
	     exit 1; \
	fi

clean:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process
	rm -rf tests/
	-$(MAKE) clean

	dh_clean

install: build test
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install BASEDIR=`pwd`/debian/tmp

	for eg in examples/*; do \
	    install -o root -g root -m 644 $$eg \
		debian/tmp/usr/share/doc/ifupdown/$$eg; \
	done
	install -o root -g root -m 755 debian/upgrade-from-0.5.x.pl \
		debian/tmp/usr/share/ifupdown/

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit -r --init-script=ifupdown -- start 39 S .
#	    ^--- is a piece of junk
	install -o root -g root -m 755 debian/ifupdown.init debian/tmp/etc/init.d/ifupdown
	dh_installcron
#	dh_installmanpages
	install -o root -g root -m 644 interfaces.5 debian/tmp/usr/share/man/man5/interfaces.5
	install -o root -g root -m 644 ifup.8 debian/tmp/usr/share/man/man8/ifup.8
	ln -s ifup.8 debian/tmp/usr/share/man/man8/ifdown.8
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs ChangeLog
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	# You may want to make some executables suid here.
	dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
